#/* Copyright (C) 2003  Vesa Karvonen
# *
# * Permission to copy, use, modify, sell and distribute this software is
# * granted provided this copyright notice appears in all copies. This
# * software is provided "as is" without express or implied warranty, and with
# * no claim as to its suitability for any purpose.
# */
#
#include "aux.hpp"
#include "sm.hpp"
#include "ops.hpp"
#include "stx.hpp"
#include "defs.hpp"
#
#/* Reducer based on substitution */
#
#define PP_EVAL(t) PP_CADR(_,PP_SM((t,_),(PP_EVAL,PP_SM_STOP)))
#
#define PP_EVAL_OP(t_ts,ps) PP_DISPATCH(PP_EVAL_,t_ts)(PP_CAR t_ts,PP_CDR t_ts,ps)
#define PP_EVAL_LAMBDA(t,ts,ps) ((t,ts),ps)
#define PP_EVAL_APPLY(t,ts,ps) ((PP_CDR t,(PP_CAR t,ts)),(PP_EVAL,(PP_SWAP,(PP_EVAL,(PP_APPLY,ps)))))
#define PP_EVAL_SYMBOL(t,ts,ps) ((FREE VARIABLE: t,_),PP_SM_STOP)
#
#define PP_APPLY_OP(t0_t1_ts,ps) ((PP_TERM(PP_CAR t0_t1_ts),PP_CDDR t0_t1_ts),(PP_SUBST,(PP_VAR(PP_CAR t0_t1_ts),(PP_CADR t0_t1_ts,(PP_EVAL,ps)))))
#
#define PP_SUBST_OP(t_ts,x_tx_ps) PP_DISPATCH(PP_SUBST_,t_ts)(PP_CAR t_ts,PP_CDR t_ts,PP_CAR x_tx_ps,PP_CADR x_tx_ps,PP_CDDR x_tx_ps)
#define PP_SUBST_SYMBOL(t,ts,x,tx,ps) ((PP_SAME(t,x)(tx,t),ts),ps)
#define PP_SUBST_LAMBDA(t,ts,x,tx,ps) PP_SAME(PP_VAR(t),x)(((t,ts),ps),((PP_TERM(t),ts),(PP_SUBST,(x,(tx,(PP_MK_LAMBDA,(PP_VAR(t),ps)))))))
#define PP_SUBST_APPLY(t,ts,x,tx,ps) ((PP_CDR t,(PP_CAR t,ts)),(PP_SUBST,(x,(tx,(PP_SWAP,(PP_SUBST,(x,(tx,(PP_MK_APPLY,ps)))))))))
#
#/* Invokes the reducer */
#
#ifndef TERM
#define TERM ((AND,FALSE),TRUE)
#endif
#
PP_EVAL(TERM)
